Index: pjproject/branches/projects/uwp/pjmedia/include/pjmedia/rtp.h
===================================================================
--- pjproject/branches/projects/uwp/pjmedia/include/pjmedia/rtp.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjmedia/include/pjmedia/rtp.h	(revision 5513)
@@ -114,5 +114,5 @@
 
 /**
- * RTP extendsion header.
+ * RTP extension header.
  */
 struct pjmedia_rtp_ext_hdr
@@ -127,4 +127,19 @@
 typedef struct pjmedia_rtp_ext_hdr pjmedia_rtp_ext_hdr;
 
+/**
+ * This will contain the RTP header decode output.
+ */
+struct pjmedia_rtp_dec_hdr
+{
+    /* RTP extension header output decode */
+    pjmedia_rtp_ext_hdr *ext_hdr;
+    pj_uint32_t *ext;
+    unsigned ext_len;
+};
+
+/**
+ * @see pjmedia_rtp_dec_hdr
+ */
+typedef struct pjmedia_rtp_dec_hdr pjmedia_rtp_dec_hdr;
 
 #pragma pack(1)
@@ -322,4 +337,36 @@
 					     unsigned *payloadlen);
 
+
+/**
+ * This function decodes incoming packet into RTP header and payload.
+ * The decode function is guaranteed to point the payload to the correct
+ * position regardless of any options present in the RTP packet.
+ *
+ * Note that this function does not modify the returned RTP header to
+ * host byte order.
+ *
+ * @param ses		The session.
+ * @param pkt		The received RTP packet.
+ * @param pkt_len	The length of the packet.
+ * @param hdr		Upon return will point to the location of the RTP
+ *			header inside the packet. Note that the RTP header
+ *			will be given back as is, meaning that the fields
+ *			will be in network byte order.
+ * @param dec_hdr	Upon return will point to the location of the 
+ *			additional RTP header inside the packet, if any.
+ * @param payload	Upon return will point to the location of the
+ *			payload inside the packet.
+ * @param payloadlen	Upon return will indicate the size of the payload.
+ *
+ * @return		PJ_SUCCESS if successfull.
+ */
+PJ_DECL(pj_status_t) pjmedia_rtp_decode_rtp2(
+				    pjmedia_rtp_session *ses,
+				    const void *pkt, int pkt_len,
+				    const pjmedia_rtp_hdr **hdr,
+				    pjmedia_rtp_dec_hdr *dec_hdr,
+				    const void **payload,
+				    unsigned *payloadlen);
+
 /**
  * Call this function everytime an RTP packet is received to check whether 
Index: pjproject/branches/projects/uwp/pjmedia/include/pjmedia/sound.h
===================================================================
--- pjproject/branches/projects/uwp/pjmedia/include/pjmedia/sound.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjmedia/include/pjmedia/sound.h	(revision 5513)
@@ -141,6 +141,11 @@
  * @return		Zero on success.
  */
-PJ_DECL(pj_status_t) pjmedia_snd_init(pj_pool_factory *factory);
-
+PJ_INLINE(pj_status_t) pjmedia_snd_init(pj_pool_factory *factory)
+{
+    /* This function is inlined to avoid pjmedia's dependency on
+     * pjmedia-audiodev.
+     */
+    return pjmedia_aud_subsys_init(factory);
+}
 
 /**
@@ -149,5 +154,11 @@
  * @return		Number of devices.
  */
-PJ_DECL(int) pjmedia_snd_get_dev_count(void);
+PJ_INLINE(int) pjmedia_snd_get_dev_count(void)
+{
+    /* This function is inlined to avoid pjmedia's dependency on
+     * pjmedia-audiodev.
+     */
+    return (int)pjmedia_aud_dev_count();
+}
 
 
@@ -324,5 +335,11 @@
  * @return		Zero on success.
  */
-PJ_DECL(pj_status_t) pjmedia_snd_deinit(void);
+PJ_INLINE(pj_status_t) pjmedia_snd_deinit(void)
+{
+    /* This function is inlined to avoid pjmedia's dependency on
+     * pjmedia-audiodev.
+     */
+    return pjmedia_aud_subsys_shutdown();
+}
 
 
Index: pjproject/branches/projects/uwp/pjmedia/include/pjmedia/stream.h
===================================================================
--- pjproject/branches/projects/uwp/pjmedia/include/pjmedia/stream.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjmedia/include/pjmedia/stream.h	(revision 5513)
@@ -34,4 +34,5 @@
 #include <pjmedia/transport.h>
 #include <pjmedia/vid_codec.h>
+#include <pjmedia/stream_common.h>
 #include <pj/sock.h>
 
@@ -343,5 +344,6 @@
  * @param stream	The media stream.
  * @param ascii_digit	String containing digits to be sent to remote as 
- *			described on RFC 2833 section 3.10. Character 'R' is 
+ *			described on RFC 2833 section 3.10. 
+ *			If PJMEDIA_HAS_DTMF_FLASH is enabled, character 'R' is
  *			used to represent the event type 16 (flash) as stated 
  *			in RFC 4730.
@@ -430,4 +432,23 @@
 pjmedia_stream_send_rtcp_bye( pjmedia_stream *stream );
 
+
+/**
+ * Get the RTP session information of the media stream. This function can be 
+ * useful for app with custom media transport to inject/filter some 
+ * outgoing/incoming proprietary packets into normal audio RTP traffics.
+ * This will return the original pointer to the internal states of the stream, 
+ * and generally it is not advisable for app to modify them.
+ *
+ * @param stream	The media stream.
+ *
+ * @param session_info	The stream session info.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t)
+pjmedia_stream_get_rtp_session_info(pjmedia_stream *stream,
+			           pjmedia_stream_rtp_sess_info *session_info);
+
+
 /**
  * @}
Index: pjproject/branches/projects/uwp/pjmedia/include/pjmedia/stream_common.h
===================================================================
--- pjproject/branches/projects/uwp/pjmedia/include/pjmedia/stream_common.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjmedia/include/pjmedia/stream_common.h	(revision 5513)
@@ -28,7 +28,33 @@
 #include <pjmedia/codec.h>
 #include <pjmedia/sdp.h>
+#include <pjmedia/rtp.h>
+#include <pjmedia/rtcp.h>
 
 
 PJ_BEGIN_DECL
+
+/**
+ * This structure describes rtp/rtcp session information of the media stream.
+ */
+typedef struct pjmedia_stream_rtp_sess_info
+{
+    /**
+     * The decode RTP session.
+     */
+    const pjmedia_rtp_session *rx_rtp;
+
+    /**
+     * The encode RTP session.
+     */
+    const pjmedia_rtp_session *tx_rtp;
+
+    /**
+     * The decode RTCP session.
+     */
+    const pjmedia_rtcp_session *rtcp;
+
+} pjmedia_stream_rtp_sess_info;
+
+
 
 /**
Index: pjproject/branches/projects/uwp/pjmedia/include/pjmedia/transport.h
===================================================================
--- pjproject/branches/projects/uwp/pjmedia/include/pjmedia/transport.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjmedia/include/pjmedia/transport.h	(revision 5513)
@@ -242,4 +242,9 @@
 
 /**
+ * Forward declaration for media transport attach param.
+ */
+typedef struct pjmedia_transport_attach_param pjmedia_transport_attach_param;
+
+/**
  * This enumeration specifies the general behaviour of media processing
  */
@@ -304,5 +309,6 @@
      * to be used by the stream for the first time, and it tells the transport
      * about remote RTP address to send the packet and some callbacks to be 
-     * called for incoming packets.
+     * called for incoming packets. This function exists for backwards
+     * compatibility. Transports should implement attach2 instead.
      *
      * Application should call #pjmedia_transport_attach() instead of 
@@ -434,4 +440,16 @@
      */
     pj_status_t (*destroy)(pjmedia_transport *tp);
+
+    /**
+     * This function is called by the stream when the transport is about
+     * to be used by the stream for the first time, and it tells the transport
+     * about remote RTP address to send the packet and some callbacks to be
+     * called for incoming packets.
+     *
+     * Application should call #pjmedia_transport_attach2() instead of
+     * calling this function directly.
+     */
+    pj_status_t (*attach2)(pjmedia_transport *tp,
+			   pjmedia_transport_attach_param *att_param);
 };
 
@@ -546,4 +564,54 @@
 };
 
+
+/**
+ * This structure describes the data passed when calling
+ * #pjmedia_transport_attach2().
+ */
+struct pjmedia_transport_attach_param
+{
+    /**
+     * The media stream.
+     */
+    void *stream;
+
+    /**
+     * Indicate the stream type, either it's audio (PJMEDIA_TYPE_AUDIO) 
+     * or video (PJMEDIA_TYPE_VIDEO).
+     */
+    pjmedia_type media_type;
+
+    /**
+     * Remote RTP address to send RTP packet to.
+     */
+    pj_sockaddr rem_addr;
+
+    /**
+     * Optional remote RTCP address. If the argument is NULL
+     * or if the address is zero, the RTCP address will be
+     * calculated from the RTP address (which is RTP port plus one).
+     */
+    pj_sockaddr rem_rtcp;
+
+    /**
+     * Length of the remote address.
+     */
+    unsigned addr_len;
+
+    /**
+     * Arbitrary user data to be set when the callbacks are called.
+     */
+    void *user_data;
+
+    /**
+     * Callback to be called when RTP packet is received on the transport.
+     */
+    void (*rtp_cb)(void *user_data, void *pkt, pj_ssize_t);
+
+    /**
+     * Callback to be called when RTCP packet is received on the transport.
+     */
+    void (*rtcp_cb)(void *user_data, void *pkt, pj_ssize_t);
+};
 
 /**
@@ -600,4 +668,30 @@
     }
     return NULL;
+}
+
+
+/**
+ * Attach callbacks to be called on receipt of incoming RTP/RTCP packets.
+ * This is just a simple wrapper which calls <tt>attach2()</tt> member of
+ * the transport if it is implemented, otherwise it calls <tt>attach()</tt>
+ * member of the transport.
+ *
+ * @param tp	    The media transport.
+ * @param att_param The transport attach param.
+ *
+ * @return	    PJ_SUCCESS on success, or the appropriate error code.
+ */
+PJ_INLINE(pj_status_t) pjmedia_transport_attach2(pjmedia_transport *tp,
+                                      pjmedia_transport_attach_param *att_param)
+{
+    if (tp->op->attach2) {
+	return tp->op->attach2(tp, att_param);
+    } else {
+	return tp->op->attach(tp, att_param->user_data, 
+			      (pj_sockaddr_t*)&att_param->rem_addr, 
+			      (pj_sockaddr_t*)&att_param->rem_rtcp, 
+			      att_param->addr_len, att_param->rtp_cb, 
+			      att_param->rtcp_cb);
+    }
 }
 
Index: pjproject/branches/projects/uwp/pjmedia/include/pjmedia/transport_srtp.h
===================================================================
--- pjproject/branches/projects/uwp/pjmedia/include/pjmedia/transport_srtp.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjmedia/include/pjmedia/transport_srtp.h	(revision 5513)
@@ -156,5 +156,5 @@
      * Specify individual crypto suite setting.
      */
-    pjmedia_srtp_crypto		crypto[8];
+    pjmedia_srtp_crypto		crypto[PJMEDIA_SRTP_MAX_CRYPTOS];
 
 } pjmedia_srtp_setting;
Index: pjproject/branches/projects/uwp/pjmedia/include/pjmedia/vid_stream.h
===================================================================
--- pjproject/branches/projects/uwp/pjmedia/include/pjmedia/vid_stream.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjmedia/include/pjmedia/vid_stream.h	(revision 5513)
@@ -32,4 +32,5 @@
 #include <pjmedia/transport.h>
 #include <pjmedia/vid_codec.h>
+#include <pjmedia/stream_common.h>
 #include <pj/sock.h>
 
@@ -117,4 +118,26 @@
 
 } pjmedia_vid_stream_rc_config;
+
+/**
+ * Structure of configuration settings for video stream sending keyframe 
+ * after it is created.
+ */
+typedef struct pjmedia_vid_stream_sk_config
+{
+    /**
+     * The number of keyframe to be sent after the stream is created.
+     *
+     * Default: PJMEDIA_VID_STREAM_START_KEYFRAME_CNT
+     */
+    unsigned			    count;
+
+    /**
+     * The keyframe sending interval after the stream is created.
+     *
+     * Default: PJMEDIA_VID_STREAM_START_KEYFRAME_INTERVAL_MSEC
+     */
+    unsigned			    interval;
+
+} pjmedia_vid_stream_sk_config;
 
 
@@ -166,4 +189,7 @@
     pjmedia_vid_stream_rc_config rc_cfg;
                                     /**< Stream send rate control settings. */
+
+    pjmedia_vid_stream_sk_config sk_cfg;
+				    /**< Stream send keyframe settings.	    */
 } pjmedia_vid_stream_info;
 
@@ -201,4 +227,12 @@
 PJ_DECL(void)
 pjmedia_vid_stream_rc_config_default(pjmedia_vid_stream_rc_config *cfg);
+
+/**
+ * Initialize the video stream send keyframe with default settings.
+ *
+ * @param cfg		Video stream send keyframe structure to be initialized.
+ */
+PJ_DECL(void)
+pjmedia_vid_stream_sk_config_default(pjmedia_vid_stream_sk_config *cfg);
 
 
@@ -413,4 +447,21 @@
 						pjmedia_vid_stream *stream);
 
+/**
+ * Get the RTP session information of the video media stream. This function 
+ * can be useful for app with custom media transport to inject/filter some 
+ * outgoing/incoming proprietary packets into normal video RTP traffics.
+ * This will return the original pointer to the internal states of the stream,
+ * and generally it is not advisable for app to modify them.
+ * 
+ * @param stream	The video media stream.
+ *
+ * @param session_info	The stream session info.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t)
+pjmedia_vid_stream_get_rtp_session_info(pjmedia_vid_stream *stream,
+				   pjmedia_stream_rtp_sess_info *session_info);
+
 
 /**
